VERSION 5.00
Begin VB.UserControl Speedometr 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   990
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2700
   FillColor       =   &H00FFFFC0&
   FillStyle       =   0  'Solid
   ScaleHeight     =   990
   ScaleWidth      =   2700
   ToolboxBitmap   =   "Speedometr.ctx":0000
End
Attribute VB_Name = "Speedometr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'    -:
Const m_def_ArrowColor = 0
Const m_def_Min = 0
Const m_def_Max = 100
Const m_def_Value = 0
'  :
Dim m_ArrowColor As OLE_COLOR
Dim m_Min As Long
Dim m_Max As Long
Dim m_Value As Long

'

Public Property Get Value() As Long
    Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Long)
    m_Value = New_Value
    PropertyChanged "Value"
    Draw
End Property

Public Property Get Min() As Long
Attribute Min.VB_Description = " "
Attribute Min.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Long)
    m_Min = New_Min
    PropertyChanged "Min"
    '     Draw,
    '..    
    '   
End Property

Public Property Get Max() As Long
Attribute Max.VB_Description = " "
Attribute Max.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Long)
    m_Max = New_Max
    PropertyChanged "Max"
    '     Draw,
    '..    
    '   
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = " "
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    Draw
End Property

Public Property Get ArrowColor() As OLE_COLOR
Attribute ArrowColor.VB_Description = " "
Attribute ArrowColor.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    ArrowColor = m_ArrowColor
End Property

Public Property Let ArrowColor(ByVal New_ArrowColor As OLE_COLOR)
    m_ArrowColor = New_ArrowColor
    PropertyChanged "ArrowColor"
    Draw
End Property

Public Property Get ConturColor() As OLE_COLOR
Attribute ConturColor.VB_Description = " "
Attribute ConturColor.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    ConturColor = UserControl.FillColor
End Property

Public Property Let ConturColor(ByVal New_ConturColor As OLE_COLOR)
    UserControl.FillColor() = New_ConturColor
    PropertyChanged "ConturColor"
    Draw
End Property

Public Property Get ArrowWidth() As Integer
Attribute ArrowWidth.VB_Description = " "
Attribute ArrowWidth.VB_ProcData.VB_Invoke_Property = ";Speedometr"
    ArrowWidth = UserControl.DrawWidth
End Property

Public Property Let ArrowWidth(ByVal New_ArrowWidth As Integer)
    UserControl.DrawWidth() = New_ArrowWidth
    PropertyChanged "ArrowWidth"
    Draw
End Property

'  
Private Sub UserControl_InitProperties()
    m_Min = m_def_Min
    m_Max = m_def_Max
    m_Value = m_def_Value
    m_ArrowColor = m_def_ArrowColor
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Min = PropBag.ReadProperty("Min", m_def_Min)
    m_Max = PropBag.ReadProperty("Max", m_def_Max)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    m_ArrowColor = PropBag.ReadProperty("ArrowColor", m_def_ArrowColor)
    UserControl.FillColor = PropBag.ReadProperty("ConturColor", &HFFFFC0)
    UserControl.DrawWidth = PropBag.ReadProperty("ArrowWidth", 2)
End Sub

Private Sub UserControl_Show()
'    
    Draw
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
    Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ArrowColor", m_ArrowColor, m_def_ArrowColor)
    Call PropBag.WriteProperty("ConturColor", UserControl.FillColor, &HFFFFC0)
    Call PropBag.WriteProperty("ArrowWidth", UserControl.DrawWidth, 2)
End Sub

Private Sub Draw()
    Cls
    Line (0, 0)-(ScaleWidth, ScaleHeight * 0.1), ConturColor, BF
    Circle (ScaleWidth * 0.5, ScaleHeight), ScaleHeight * 0.1, ConturColor
    ' 
    Line (ScaleWidth * 0.5, ScaleHeight)-(ScaleWidth * m_Value / (m_Max - m_Min), 0), m_ArrowColor
End Sub


